//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                               s-PSI@Log_Clear.mq4 |
//|                                       Copyright  2013, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//| 14.04.2013       ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  - |
//|      (TarasBY).    - |
//|      ,    .       |
//|     ()    .                          |
//|         ,    - |
//| .                                                               |
//|     ,    ,     |
//|    Skype: TarasBY  e-mail.                             |
//+-----------------------------------------------------------------------------------+
//|   This product is intended for non-commercial use.  The publication is only allo- |
//|wed when you specify the name of the author (TarasBY). Edit the source code is va- |
//|lid only under condition of preservation of the text, links and author's name.     |
//|   Selling a script or(and) parts of it PROHIBITED.                                |
//|   The author is not liable for any damages resulting from the use of a script.    |
//|   For all matters relating to the work of the script, comments or suggestions for |
//|their improvement in the contact Skype: TarasBY or e-mail.                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
#property show_inputs
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string FileName           = "";             //  -
extern bool   IsTester           = True;           //  
extern string ExcludeWords.List  = "";             //  ( ",")   ,   
extern string WorkFolder         = "";             //   : _\experts\files (_\tester\files    )
//IIIIIIIIIIIIIIIIIIII======  =======IIIIIIIIIIIIIIIIIIIIII+
string        gsa_NotRead[] = {"successfully","Cannot","uninit","removed","TestGenerator",
                               "initialized","deinitialized","Compiling"};
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
#include      <b-PSI@Arrays.mqh>                   //     
#include      <b-PSI@BaseZF.mqh>                   //   
#include      <b-PSI@Log.mqh>                      //     -
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom script iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    int      li_start = GetTickCount();
    datetime ldt_Time = TimeCurrent();
    string   ls_Year = TimeYear (ldt_Time), ls_Month = TimeMonth (ldt_Time), ls_Day = TimeDay (ldt_Time);
//----
    //----          
    if (StringLen (ls_Month) == 1) ls_Month = StringConcatenate (0, ls_Month);
    if (StringLen (ls_Day) == 1) ls_Day = StringConcatenate (0, ls_Day);
    if (FileName == "") FileName = StringConcatenate (ls_Year, ls_Month, ls_Day);
//----
    int    lia_Time[][2], lia_Date[3];
    string ls_FileName, ls_File = ".log", lsa_Row[0], ls_Name = FileName,
           ls_WorkFolder = "", lsa_SET[], ls_Date;
    bool   lb_continue = false, lb_write = false;
//----
    //----     (  )
    //----      files     log,     
    if (WorkFolder == "/") {if (IsTester) ls_WorkFolder = "test"; else ls_WorkFolder = "on-line";}
    else ls_WorkFolder = WorkFolder;
    //----      
    fAdd_ListToArraySTR (gsa_NotRead, ExcludeWords.List, ",");
    //----    
    fCheck_DublicateSTR (gsa_NotRead);
    //----     ,  - 
    if (fCheck_ValidDate (ls_Name, lia_Date))
    {
        int li_Len = StringLen (ls_Name);
        if (li_Len > 8) ls_Name = StringSubstr (ls_Name, 0, li_Len - 8);
        else ls_Name = "";
        //----   -
        datetime ldt_Date = fGet_TimeFromArray (lia_Date);
        //----      
        int li_Day = TimeDayOfYear (ldt_Date), li_curDay = TimeDayOfYear (ldt_Time);
        if (li_Day < li_curDay)
        {
            string lsa_TMP[],
            ls_row = "*******************************************";
            for (int li_IND = 0; li_IND <= li_curDay - li_Day; li_IND++)
            {
                ldt_Time = ldt_Date + li_IND * PERIOD_D1 * 60;
                ls_Date = fGet_NameFromTime (ldt_Time);
                //Print ("Name from Date = ", ls_Date);
                ls_FileName = StringConcatenate (ls_Name, ls_Date, ls_File);
                //Print ("Name - ", ls_FileName);
                if (fRead_FileToArray (lsa_TMP, gsa_NotRead, ls_FileName, ls_WorkFolder))
                {
                    lb_write = true;
                    int li_size = ArraySize (lsa_Row);
                    ArrayResize (lsa_Row, li_size + 1);
                    //----    / 
                    lsa_Row[li_size] = StringConcatenate (ls_row, "||--", TimeToStr (ldt_Time, TIME_DATE), "--||", ls_row);
                    fComplete_ArraysSTR (lsa_Row, lsa_TMP);
                    
                }
            }
            lb_continue = true;
        }
    }
    //----              
    if (!lb_continue)
    {
        ls_FileName = StringConcatenate (FileName, ls_File);
        if (fRead_FileToArray (lsa_Row, gsa_NotRead, ls_FileName, ls_WorkFolder)) {lb_write = true;}
    }
    //----   ,   
    if (lb_write)
    {
        //----       
        fPrepare_Arrays (lsa_Row, lia_Time, lsa_SET, IsTester, True);
        //----    
        if (StringSubstr (FileName, StringLen (FileName) - 2) == ls_Day) ls_Day = "";
        else ls_Day = StringConcatenate ("-", ls_Day);
        //----  
        fWrite_FileFromArray (lsa_Row, StringConcatenate (FileName, ls_Day, "(C).log"), ls_WorkFolder);
    }
    //----    
    int    li_Time = GetTickCount() - li_start;      //     
    string ls_msg = StringConcatenate ("  : ", fTimeToStr (li_Time));
    Print (ls_msg);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

